#!/bin/sh
# test the CPU state
# Tim Hockin

. /usr/sausalito/swatch/statecodes

# set defaults
if [ -z $rThreshhold ]; then
	rThreshhold="6.0"
fi
if [ -z $yThreshhold ]; then
	yThreshhold="4.0"
fi

# acquire data
read AVG1 AVG5 AVG15 REST < /proc/loadavg

# decide
if [ `echo "$AVG15 >= $rThreshhold" | bc -l` = "1"  -o \
     `echo "$AVG1 >= ($rThreshhold * 2)" | bc -l` = "1" ]; then
	echo -ne "[[base-am.amCPUWarning_heavy]]"
	exit $AM_STATE_RED
fi

if [ `echo "$AVG15 >= $yThreshhold" | bc -l` = "1" -o \
     `echo "$AVG1 >= ($yThreshhold * 2)" | bc -l` = "1" ]; then
	echo -ne "[[base-am.amCPUWarning_moderate]]"
	exit $AM_STATE_YELLOW
fi

echo -ne "[[base-am.amCPUWarning_light]]"
exit $AM_STATE_GREEN
