#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: am_mem.pl,v 1.10 2002/03/08 07:07:45 uzi Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# test the memory state

use AM::Util;
use strict;

my %am_states = am_get_statecodes();
my ($memYellow, $memRed);
my $errcount;
my $debug = 0;

sub dprint
{
	if ($debug) {
		print @_;
	}
}

# init threshholds
if (!defined($ENV{memYellow})) {
	$ENV{memYellow} = 80;
}
if (!defined($ENV{memRed})) {
	$ENV{memRed} = 90;
}

# get memory numbers
open(MEM, "</proc/meminfo");

# read header
<MEM>;

# read mem line
$_ = <MEM>;
my @minfo = split(/\s+/);

# read swap line
$_ = <MEM>;
my @sinfo = split(/\s+/);

close(MEM);

# Mem free + buffered + swap free
my $free = $minfo[3] + $minfo[5] + $sinfo[3];
dprint("free  = $free\n");

# Total mem + total swap
my $total = $minfo[1] + $sinfo[1];
dprint("total = $total\n");

my $used = $total - $free;
my $pct = $used / $total * 100 + 0.5;

dprint("used  = $used\n");
dprint("pct   = $pct\n");

if ($pct > $ENV{memRed}) {
	print("[[base-am.amMemWarning_heavy]]");
	exit $am_states{AM_STATE_RED};
}

if ($pct > $ENV{memYellow}) {
	print("[[base-am.amMemWarning_moderate]]");
	exit $am_states{AM_STATE_YELLOW};
}

print("[[base-am.amMemWarning_light]]");
exit $am_states{AM_STATE_GREEN};
